/* 
   31337 recoder;)

   Copyright (C) 2002 Marek "Tilk" Materzok <tilk@lucifer.geos.pl>

   Ideas: Andrzej Lindnal <sznik@osama.geos.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "recoder.h"
#include "recoder_b64.h"

void
B64Recoder::DoEncode()
{
	char enctable[] = {
		'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 
		'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 
		'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 
		'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', 
		'4', '5', '6', '7', '8', '9', '+', '/', '='
	};
	int column = 0;
	char obuf[5];
	obuf[4] = 0;
	while (istr)
	{
		unsigned char ibuf[3];
		int icnt;

		for (icnt = 0; icnt < 3; icnt++)
		{
			char uzn;
			istr.get(uzn);
			ibuf[icnt] = uzn;
			if (!istr)
			{
				break;
			}
		}
		if (icnt == 0) break;
		for (int n = icnt; n < 3; n++) ibuf[n] = 0;

		obuf[0] = ibuf[0] >> 2;
		obuf[1] = ((ibuf[0] << 4) & 0x30) | (ibuf[1] >> 4);
		if (icnt >= 2) obuf[2] = ((ibuf[1] << 2) & 0x3c) | (ibuf[2] >> 6); 
		else obuf[2] = 64;
		if (icnt == 3) obuf[3] = ibuf[2] & 0x3f; 
		else obuf[3] = 64;

		for (int n = 0; n < 4; n++)
		{
			obuf[n] = enctable[obuf[n]];
		}
		
		if (column == 76)
		{
			column = 0;
			*ostr << "\n";
		}
		*ostr << obuf;
		column += 4;
	}
}

void
B64Recoder::DoDecode()
{
	char dectable[256] = {
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	62,	0,	0,	0,	63,	
		52,	53,	54,	55,	56,	57,	58,	59,	60,	61,	0,	0,	0,	0,	0,	0,	
		0,	 0,	 1,	 2,	 3,	 4,	 5,	 6,	 7,	 8,	 9,	10,	11,	12,	13,	14,	
		15,	16,	17,	18,	19,	20,	21,	22,	23,	24,	25,	0,	0,	0,	0,	0,	
		0,	26,	27,	28,	29,	30,	31,	32,	33,	34,	35,	36,	37,	38,	39,	40,	
		41,	42,	43,	44,	45,	46,	47,	48,	49,	50,	51,	0,	0,	0,	0,	0,
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
		0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	
	};
	
	bool complete = true;
	while (istr)
	{
		unsigned char ibuf[4];
		for (int n = 0; n < 4; n++)
		{
			char uzn;
			istr.get(uzn);
			ibuf[n] = uzn;
			if (!istr)
			{
				complete = false;
				break;
			}
			if (ibuf[n] == ' ' || ibuf[n] == '\n' || ibuf[n] == '\t'
					|| ibuf[n] == '\r')
			{
				n--; continue;
			}
		}
		if (!complete) break;
		
		*ostr << static_cast<char>(
			((dectable[ibuf[0]] << 2) | (dectable[ibuf[1]] >> 4)));
		if (ibuf[2] != '=') *ostr << static_cast<char>(
				((dectable[ibuf[1]] << 4) | (dectable[ibuf[2]] >> 2)));
		if (ibuf[3] != '=') *ostr << static_cast<char>(
				((dectable[ibuf[2]] << 6) | (dectable[ibuf[3]])));
	};
}

