/* 
   31337 recoder;)

   Copyright (C) 2002 Marek "Tilk" Materzok <tilk@lucifer.geos.pl>

   Ideas: Andrzej Lindnal <sznik@osama.geos.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "recoder.h"
#include "recoder_rot.h"

void
ROTRecoder::DoEncode()
{
	Recode();
}

void
ROTRecoder::DoDecode()
{
	rotate_key = -rotate_key;
	Recode();
	rotate_key = -rotate_key;
}

void
ROTRecoder::Recode()
{
	while (istr)
	{
		unsigned char zn; char uzn;
		istr.get(uzn);
		zn = uzn;
		if (!istr) break;
		int znak = zn;

		znak = zn + rotate_key;
		if (binary)
		{
			while (znak < 0) znak += 256;
			while (znak > 255) znak -= 256;
		}
		else
		{
			if (zn >= 'a' && zn <= 'z')
			{
				while (znak < 'a') znak += 26;
				while (znak > 'z') znak -= 26;
			} else
			if (zn >= 'A' && zn <= 'Z')
			{
				while (znak < 'A') znak += 26;
				while (znak > 'Z') znak -= 26;
			} else
			if (zn >= '0' && zn <= '9' && digits)
			{
				while (znak < '0') znak += 10;
				while (znak > '9') znak -= 10;
			} else
				znak -= rotate_key;
		}

		*ostr << static_cast<char>(znak);
	}
}

void
ROTRecoder::ScanOpts()
{
	binary = options.HasOpt("binary");
	digits = options.HasOpt("digits");
	if (binary) digits = false;
	rotate_key = options.IntOptVal("key");
	if (rotate_key < 1 || rotate_key > 26)
		throw RecoderError(_("Supported ROTs: 1 - 26.\n"));
};

